//--------------------------------------------------------------------//
// ΐ_̐E ver 1.1

var canvas;			// LoXvf
var context;	 		// ReLXg
var pressed;			// }EX{^
var mx,my;			// }EXʒu
var step;			// vZXebv
var running;			// vZsXCb`

var t;				// 
var tend;			// I
var xs1=[],xs2=[];		// v_xW
var dx;				// v_̋ԍݕ
var colors1=[],colors2=[];	// v_̕\F
var motions;			// ^ł̎ExExEʒu
var baseToAcc;			// n猩n̈ʒu֐
var accToAcc;			// n猩ʒu֐

var clock;			// `pv
var sys1,sys2;			// nEn\t[
var graph;			// Ot
var x0,x01,x02;			// _̕`ʒu
var w;				// Pʒ̕`TCY
var view;			// _
var acc0;			// n_|C^

// _
var BASE_VIEW=1;		// n_
var ACC_VIEW=2;			// n_

var DT=0.01;			// ԍݕ
var FONT_SIZE=14;		// tHgTCY
var SCALE_SIZE=4;		// ڐ`TCY
var LOG10=Math.log(10);		// log10
var BG_COLOR='rgb(0,0,0)';		// wiF
var FG_COLOR='rgb(255,255,255)';	// OiF
var ACC_COLOR='rgb(255,51,102)';	// x`F
var VEL_COLOR='rgb(51,255,51)';		// x`F

// f[^
// t1,a1 - n̎Ex
// xs20,xs21 - ňv_xW͈̔
// dx2 - v_xWݕ
function initRelativity(t1,a1,xs20,xs21,dx2){
  t=0;
  step=0;
  initCanvas();
  xs2=createArray(xs20,xs21,dx2);
  dx=dx2;
  acc0=searchArrayNearest(xs2,0);
  var count=Math.min(t1.length,a1.length);
  var xr=Math.max(Math.abs(xs2[0]),Math.abs(xs2[xs2.length-1]));
  var acc=new LinearFunc(count,t1,a1);
  motions=new Motions(DT,t1[count-1],xr,acc,0,0);
  accToAcc=motions.getAccVel();
  baseToAcc=motions.distribution(xs2);
  xs1=setScale(motions.xMin,motions.xMax,dx);
  colors1=setColorBar(xs1.length);
  colors2=setColorBar(baseToAcc.length);
  setBorders();
  setView();
  loop();
}

// z쐬
// a0,a1 - f[^͈
// da - ݕ
function createArray(a0,a1,da){
  var array=[],a=a0;
  while(a<=a1){
    array.push(a);
    a+=da;
  }
  return array;
}

// z̍ŋߖTvfʒuԂ
// array - z
// a - ߖTTl
function searchArrayNearest(array,a){
  var da=Math.abs(array[0]-a),inear=0;
  var dmin=da;
  for(var i=1;i<array.length;i++){
    da=Math.abs(array[i]-a);
    if(da<dmin){
      dmin=da;
      inear=i;
    }
  }
  return inear;
}

// LoX
function initCanvas(){
  canvas=document.getElementById('relativity');
  canvas.width=canvas.clientWidth;
  canvas.height=canvas.clientHeight;
  canvas.addEventListener('mousedown',mousePressed,false);
  canvas.addEventListener('mouseup',mouseReleased,false);
  canvas.addEventListener('mousemove',mouseMoved,false);
  context=canvas.getContext('2d');
  context.strokeStyle=FG_COLOR;
  context.font=FONT_SIZE+"px 'Arial'";
  context.textBaseline='top';
  pressed=false;
  mx=0;
  my=0;
  graph=new GraphWindow('n̎','');
}

// `拫Eݒ肷
function setBorders(){
  w=parseInt(0.8*canvas.width/(motions.xMax-motions.xMin));
  var r=w/2*dx,y1=parseInt(r+2*FONT_SIZE);
  x01=parseInt(4*r-w*motions.xMin);
  x02=parseInt(0.5*canvas.width);
  sys1=new SysFrame('n',y1,r);
  sys2=new SysFrame('n',y1+2*r+4*FONT_SIZE,r);
  clock=new Clock(2*Math.PI/motions.tend,r,0.9*r);
  var yg=parseInt(sys2.yl+FONT_SIZE+15)
  graph.setBorder(w,yg,canvas.width-2*w,
      	      	  parseInt(canvas.height-r)-yg-2*FONT_SIZE);
  var amax=Math.max.apply(null,motions.a);
  var amin=Math.min.apply(null,motions.a);
  var vmax=Math.max.apply(null,motions.v);
  var vmin=Math.min.apply(null,motions.v);
  graph.setAxis(0,motions.tdend,1.1*Math.min(amin,vmin),
      	      	1.1*Math.max(amax,vmax));
}

// }EX{^̏s
function mousePressed(e){
  pressed=true;
  mx=e.clientX;
  my=e.clientY;
  calcStop();
}

// }EX{^𗣂̏s
function mouseReleased(e){
  pressed=false;
}

// }EX{^ړ̏s
function mouseMoved(e){
  if(pressed){
    mx=e.clientX;
    my=e.clientY;
  }
}

// `悷
function draw(){
  context.fillStyle=BG_COLOR;
  context.fillRect(0,0,canvas.width,canvas.height);
  context.fillStyle=FG_COLOR;
  context.beginPath();
  sys1.drawUnderline();
  sys2.drawUnderline();
  context.closePath();
  context.stroke();
  graph.draw(accToAcc.t,accToAcc.a,accToAcc.v,ACC_COLOR,VEL_COLOR);

  var i;
  if(view==BASE_VIEW){
    sys1.drawLabel(t);
    sys2.drawLabel();
    for(i=0;i<xs1.length;i++){
      sys1.drawClock(t,xs1[i],xs1[i]);
    }
    sys2.drawShip(baseToAcc[acc0].x.getValue(t));
    for(i=0;i<baseToAcc.length;i++){
      context.strokeStyle=colors2[i];
      context.fillStyle=colors2[i];
      sys2.drawClock(baseToAcc[i].td.getValue(t),
      	      	     baseToAcc[i].x.getValue(t),xs2[i]);
      graph.drawVericalLine(baseToAcc[i].td.getValue(t));
    }
    context.strokeStyle=FG_COLOR;
  }
  else{
    sys1.drawLabel();
    sys2.drawLabel(t);
    sys2.drawShip(xs2[acc0]);
    for(i=0;i<xs2.length;i++){
      sys2.drawClock(t,xs2[i],xs2[i]);
    }
    var t1=[],x1=[],ft1,fx1,xsc;
    for(i=0;i<baseToAcc.length;i++){
      t1[i]=baseToAcc[i].t.getValue(t);
      x1[i]=baseToAcc[i].x2.getValue(t);
    }
    ft1=new LinearFunc(x1.length,x1,t1);
    fx1=new LinearFunc(x1.length,x1,xs2);
    var ix0=Math.floor(motions.xMin/dx);
    var ix1=Math.ceil(x1[0]/dx);
    var ix2=Math.floor(x1[x1.length-1]/dx);
    for(i=ix1;i<=ix2;i++){
      context.strokeStyle=colors1[i-ix0];
      context.fillStyle=colors1[i-ix0];
      xsc=dx*i;
      sys1.drawClock(ft1.getValue(xsc),fx1.getValue(xsc),xsc);
    }
    context.strokeStyle=FG_COLOR;
    graph.drawVericalLine(t);
  }

  var yt=graph.y-parseInt(1.5*FONT_SIZE);
  var metrix=context.measureText('x');
  context.fillStyle=ACC_COLOR;
  context.fillText('x',20,yt);
  context.fillStyle=VEL_COLOR;
  context.fillText('x',25+metrix.width,yt);
}

// ڐݒ肷
// minValue,maxValue - f[^ŏlEől
// scale - ڐ
function setScale(minValue,maxValue,scale){
  var xm=Math.max(Math.abs(minValue),Math.abs(maxValue));
  xm=Math.min(xm,maxValue-minValue);
  if((scale===undefined) || (scale===null)){
    scale=Math.pow(10,Math.floor(Math.log(xm)/LOG10));
  }
  var scaleMin=scale*Math.ceil(minValue/scale);
  var scaleMax=scale*Math.floor(maxValue/scale);
  var count=parseInt((scaleMax-scaleMin)/scale)+1,x=[];
  for(var i=0;i<count;i++){
    x[i]=scaleMin+scale*i;
  }
  return x;
}

// J[o[̐Fݒ肷
// count - F̐
function setColorBar(count){
  var colors=[];
  for(var i=0;i<count;i++){
    colors[i]=colorBar(i/(count-1));
  }
  return colors;
}

// [v֐
function loop(){
  if(running){
    if(t<tend){
      step++;
      t+=DT;
      draw();
    }
    else{
      calcStop();
    }
  }
  requestAnimationFrame(loop);
}

// _ؑ
function setView(){
  running=false;
  t=0;
  step=0;
  var elems=document.getElementsByName('view');
  if(elems[0].checked){
    view=BASE_VIEW;
    tend=motions.tend;
    x0=x01;
  }
  else{
    view=ACC_VIEW;
    tend=motions.tdend;
    x0=x02;
  }
  draw();
}

// vZ
function calcInit(){
  running=false;
  t=0;
  step=0;
  draw();
}

// vZJn
function calcStart(){
  running=true;
}

// vZ~
function calcStop(){
  running=false;
}

//--------------------------------------------------------------------//
// ^ł̎ExExEʒu
// dt - ԍݕ
// te - vZI
// xr - vZԔ]vZ
// acc - x\֐
// v0 - x
// x0 - ʒu
var Motions=function(dt,te,xr,acc,v0,x0){
  this.dt=dt;
  this.dcount=Math.round(xr/dt);
  this.count=Math.round(te/dt)+2*this.dcount;
  var acc0=0.5*Math.log((1+v0)/(1-v0));		// atanh(v0)
  this.td=[];					// nt'
  this.a=[];					// xa
  this.v=[];					// xv

  var i;
  for(i=0;i<this.count;i++){
    this.td[i]=dt*i-xr;
    this.a[i]=acc.getValue(this.td[i]);
  }
  var ai=trapezoidal(this.count,this.a,dt,acc0);
  var sh=[],ch=[],e1,e2;
  for(i=0;i<this.count;i++){
    e1=Math.exp(ai[i]);
    e2=Math.exp(-ai[i]);
    sh[i]=0.5*(e1-e2);				// sinh(ai)
    ch[i]=0.5*(e1+e2);				// cosh(ai)
    this.v[i]=sh[i]/ch[i];
  }
  this.x=trapezoidal(this.count,sh,dt,x0);	// nWx
  this.t=trapezoidal(this.count,ch,dt,-xr);	// nt
  this.tend=this.t[this.count-this.dcount];	// nI
  this.tdend=this.td[this.count-this.dcount];	// nI
  this.xMin=0;
  this.xMax=0;
};

// ԕzԂ
// xs - n̍Wx'i[z
Motions.prototype.distribution=function(xs){
  var xx=[];
  this.xMin=1e6;
  this.xMax=-1e6;
  for(var j=0;j<xs.length;j++){
    xx[j]=this.distribution1(xs[j]);
  }
  return xx;
};

// ԁEψʊ֐Ԃ
// xd - n̍Wx'
Motions.prototype.distribution1=function(xd){
  var w=Math.round(xd/this.dt),n=this.count-this.dcount;
  var tt=[],xx=[];
  for(var i=this.dcount;i<n;i++){
    var i1=i+w,i2=i-w,ii=i-this.dcount;
    tt[ii]=0.5*(this.t[i1]+this.t[i2]+this.x[i1]-this.x[i2]);
    xx[ii]=0.5*(this.x[i1]+this.x[i2]+this.t[i1]-this.t[i2]);
    this.xMin=Math.min(this.xMin,xx[ii]);
    this.xMax=Math.max(this.xMax,xx[ii]);
  }
  var tdd=this.td.slice(this.dcount,n);
  n-=this.dcount;
  return new TDisp(new LinearFunc(n,tt,tdd),new LinearFunc(n,tdd,tt),
      	      	   new LinearFunc(n,tt,xx),new LinearFunc(n,tdd,xx));
};

// n̎ԁExExԂ
Motions.prototype.getAccVel=function(){
  var n1=this.dcount,n2=this.count-this.dcount;
  return new AccVel(this.td.slice(n1,n2),this.a.slice(n1,n2),
      	      	    this.v.slice(n1,n2));
};

//--------------------------------------------------------------------//
// `ϕlԂ
// n - _̐
// y - _̊֐lyi[z
// dx - x̍ݕ
// y0 - 萔
function trapezoidal(n,y,dx,y0){
  var i,yi=[];
  yi[0]=0.0;
  for(i=1;i<n;i++){
    yi[i]=yi[i-1]+y[i-1]+y[i];
  }
  for(i=0;i<n;i++){
    yi[i]=0.5*dx*yi[i]+y0;
  }
  return yi;
}

//--------------------------------------------------------------------//
// ExExf[^
// t - 
// a - x
// v - x
var AccVel=function(t,a,v){
  this.t=t;
  this.a=a;
  this.v=v;
}

//--------------------------------------------------------------------//
// Eψʊ֐f[^
// td - nԁ|nԊ֐
// t - nԁ|nԊ֐
// x - nԁ|nψʊ֐
// x2 - nԁ|nψʊ֐
var TDisp=function(td,t,x,x2){
  this.td=td;
  this.t=t;
  this.x=x;
  this.x2=x2;
}

//--------------------------------------------------------------------//
// Ԋ֐
// n - _̐
// x - _xWi[z
// y - _yWi[z
var LinearFunc=function(n,x,y){
  this.n=n;
  this.x=x;
  this.y=y;
  this.coef=[];
  for(var i=0;i<n-1;i++){
    this.coef[i]=(y[i+1]-y[i])/(x[i+1]-x[i]);
  }
};

// ԂlԂ
// xp - ϐl
LinearFunc.prototype.getValue=function(xp){
  if((this.n<2) || (xp<=this.x[0])){
    return this.y[0];
  }
  else if(xp>=this.x[this.n-1]){
    return this.y[this.n-1];
  }
  else{
    var low=0,high=this.n-1;
    do{
      var mid=parseInt((low+high)/2);
      if(this.x[mid]<=xp)     low=mid+1;
      else if(this.x[mid]>xp) high=mid;
    }while(low<high);
    var i=parseInt((low+high)/2)-1;
    return this.coef[i]*(xp-this.x[i])+this.y[i];
  }
};

//--------------------------------------------------------------------//
// `pv
// dth - v]p
// r - vg`攼a
// l - j
var Clock=function(dth,r,l){
  this.dth=dth;
  this.r=r;
  this.l=l;
}

// v`悷
// t - 
// x,y - \ʒu
Clock.prototype.draw=function(t,x,y){
  context.beginPath();
  context.arc(x,y,this.r,0,2*Math.PI,false);
  context.moveTo(x,y);
  var th=this.dth*t;
  context.lineTo(x+parseInt(this.l*Math.sin(th)),
      	      	 y-parseInt(this.l*Math.cos(th)));
  context.closePath();
  context.stroke();
};

//--------------------------------------------------------------------//
// nEn\t[
// label - nx
// y0 - ʒu
// r - vg`攼a
var SysFrame=function(label,y0,r){
  this.label=label;
  this.y0=y0;
  this.yt1=y0-r-FONT_SIZE-5;	// nx\ʒu
  this.yt2=y0+r+5;		// W\ʒu
  this.yl=y0+r+2*FONT_SIZE;	// g[
  this.s=parseInt(0.8*r);	// FD`TCY
  this.s2=parseInt(0.4*r);	// FD`TCY
}

// `悷
SysFrame.prototype.drawUnderline=function(){
  context.moveTo(0,this.yl);
  context.lineTo(canvas.width,this.yl);
};

// v`悷
// t - 
// x - `ʒu
// xLabel - \W
SysFrame.prototype.drawClock=function(t,x,xLabel){
  var px=parseInt(w*x)+x0;
  clock.draw(t,px,this.y0);
  context.fillText(xLabel.toFixed(1),px-10,this.yt2);
};

// FD`悷
// x - `ʒu
SysFrame.prototype.drawShip=function(x){
  var px=parseInt(w*x)+x0;
  context.beginPath();
  context.moveTo(px-this.s,this.yt1);
  context.lineTo(px+this.s2,this.yt1);
  context.lineTo(px+this.s,this.yt1+parseInt(0.5*FONT_SIZE));
  context.lineTo(px+this.s2,this.yt1+FONT_SIZE);
  context.lineTo(px-this.s,this.yt1+FONT_SIZE);
  context.closePath();
  context.stroke();
};

// x`悷
// t - 
SysFrame.prototype.drawLabel=function(t){
  if((t===undefined) || (t===null)){
    context.fillText(this.label,10,this.yt1);
  }
  else{
    context.fillText(this.label+' t='+t.toFixed(3),10,this.yt1);
  }
  context.fillText('W',10,this.yt2);
};

//--------------------------------------------------------------------//
// Ot
// xLabel - xx
// yLabel - yx
var GraphWindow=function(xLabel,yLabel){
  this.x=0;		// `̈
  this.y=0;
  this.width=0;
  this.height=0;
  this.xAxis=new GraphAxis(xLabel);
  this.yAxis=new GraphAxis(yLabel);
};

// Eݒ肷
// x,y,width,height - \ʒuAA
GraphWindow.prototype.setBorder=function(x,y,width,height){
  this.x=x;
  this.y=y;
  this.width=width;
  this.height=height;
};

// f[^ݒ肷
// xMin,xMax,yMin,yMax - xEỹf[^͈
GraphWindow.prototype.setAxis=function(xMin,xMax,yMin,yMax){
  this.xAxis.setScale(xMin,xMax);
  this.yAxis.setScale(yMin,yMax);
  this.xAxis.setCoef(this.x,this.width,1);
  this.yAxis.setCoef(this.y+this.height,this.height,-1);
};

// Ot`悷
// x - f[^xW
// y1,y2 - f[^1,2yW
// color1,color2 - Ot\F
GraphWindow.prototype.draw=function(x,y1,y2,color1,color2){
  context.strokeStyle=color1;
  this.drawData(x,y1);
  context.strokeStyle=color2;
  this.drawData(x,y2);
  context.strokeStyle=FG_COLOR;
  this.drawBorder();
};

// Otf[^`悷
// x,y - f[^x,yW
GraphWindow.prototype.drawData=function(x,y){
  var len=x.length;
  if(len===0) return;
  context.beginPath();
  var x1=this.xAxis.toView(x[0]);
  var y1=this.yAxis.toView(y[0]);
  var contain1=((this.x<=x1) && (x1<=this.x+this.width)
      	     && (this.y<=y1) && (y1<=this.y+this.height));
  for(var i=1;i<len;i++){
    var x2=this.xAxis.toView(x[i]);
    var y2=this.yAxis.toView(y[i]);
    var contain2=((this.x<=x2) && (x2<=this.x+this.width)
      	       && (this.y<=y2) && (y2<=this.y+this.height));
    if(contain1 && contain2){
      context.moveTo(x1,y1);
      context.lineTo(x2,y2);
    }
    else if(contain1){
      this.drawLineBorders(x1,y1,x2,y2);
    }
    else if(contain2){
      this.drawLineBorders(x2,y2,x1,y1);
    }
    x1=x2;
    y1=y2;
    contain1=contain2;
  }
  context.closePath();
  context.stroke();
};

// gׂOt`悷
// x1,y1 - ̈̓_x,yW
// x2,y2 - ̈O̓_x,yW
GraphWindow.prototype.drawLineBorders=function(x1,y1,x2,y2){
  var xx,yy;
  if(x2<this.x){
    yy=(y2-y1)*(this.x-x1)/(x2-x1)+y1;
    if(yy<this.y){
      xx=(x2-x1)*(this.y-y1)/(y2-y1)+x1;
      context.moveTo(x1,y1);
      context.lineTo(xx,this.y);
    }
    else if(yy>this.y+this.height){
      xx=(x2-x1)*(this.y+this.height-y1)/(y2-y1)+x1;
      context.moveTo(x1,y1);
      context.lineTo(xx,this.y+this.height);
    }
    else{
      context.moveTo(x1,y1);
      context.lineTo(this.x,yy);
    }
  }
  else if(x2>this.x+this.width){
    yy=(y2-y1)*(this.x+this.width-x1)/(x2-x1)+y1;
    if(yy<this.y){
      xx=(x2-x1)*(this.y-y1)/(y2-y1)+x1;
      context.moveTo(x1,y1);
      context.lineTo(xx,this.y);
    }
    else if(yy>this.y+this.height){
      xx=(x2-x1)*(this.y+this.height-y1)/(y2-y1)+x1;
      context.moveTo(x1,y1);
      context.lineTo(xx,this.y+this.height);
    }
    else{
      context.moveTo(x1,y1);
      context.lineTo(this.x+this.width,yy);
    }
  }
  else if(y2<this.y){
    xx=(x2-x1)*(this.y-y1)/(y2-y1)+x1;
    context.moveTo(x1,y1);
    context.lineTo(xx,this.y);
  }
  else if(y2>this.y+this.height){
    xx=(x2-x1)*(this.y+this.height-y1)/(y2-y1)+x1;
    context.moveTo(x1,y1);
    context.lineTo(xx,this.y+this.height);
  }
};

// Otg`悷
GraphWindow.prototype.drawBorder=function(){
  context.strokeRect(this.x,this.y,this.width,this.height);
  this.xAxis.drawHorizontal(this.x,this.y+this.height,this.width);
  this.yAxis.drawVertical(this.x,this.y,this.height);
};

// `悷
// x - xW
GraphWindow.prototype.drawVericalLine=function(x){
  var px=this.xAxis.toView(x);
  context.beginPath();
  context.moveTo(px,this.y);
  context.lineTo(px,this.y+this.height);
  context.stroke();
};

//--------------------------------------------------------------------//
// Ot
// text - x
var GraphAxis=function(text){
  this.text=text;
  this.scaleMin=0;	// ͈͍ŏl
  this.scaleMax=1;	// ͈͍ől
  this.sMin=0;
  this.sMax=0;
  this.scale=1;		// ڐ
  this.coef1=1;		// f[^|`ʒuϊW
  this.coef0=0;
  this.scaleLabel=[];	// ڐlx
  this.setScaleLabel();
};

// Otڐݒ肷
// minValue,maxValue - f[^ŏlEől
GraphAxis.prototype.setScale=function(minValue,maxValue){
  if(minValue>=maxValue){
    this.scaleMin=maxValue;
    this.scaleMax=this.scaleMin+1;
    this.sMin=maxValue;
    this.sMax=this.sMin+1;
    this.scale=1;
  }
  else{
    var xm=Math.max(Math.abs(minValue),Math.abs(maxValue));
    xm=Math.min(xm,maxValue-minValue);
    this.scale=Math.pow(10,Math.floor(Math.log(xm)/LOG10));
    this.scaleMin=this.scale*Math.ceil(minValue/this.scale);
    this.scaleMax=this.scale*Math.floor(maxValue/this.scale);
    this.sMin=minValue;
    this.sMax=maxValue;
  }
  this.setScaleLabel();
};

// Otڐxݒ肷
GraphAxis.prototype.setScaleLabel=function(){
  var count=parseInt((this.scaleMax-this.scaleMin)/this.scale)+1;
  this.scaleLabel.length=0;
  for(var i=0;i<count;i++){
    this.scaleLabel[i]=this.toLabel(this.scaleMin+this.scale*i);
  }
};

// Wݒ肷
// p0 ʒu
// range \͈
// direc @1F@-1F
GraphAxis.prototype.setCoef=function(p0,range,direc){
  this.coef1=direc*range/(this.sMax-this.sMin);
  this.coef0=p0-this.coef1*this.sMin;
};

// f[^`ʒuɕϊ
// x f[^
GraphAxis.prototype.toView=function(x){
  return parseInt(this.coef1*x+this.coef0);
};

// `ʒuf[^ɕϊ
// x `ʒu
GraphAxis.prototype.toData=function(x){
  return (x-this.coef0)/this.coef1;
};

// `悷
// x0,y0 - x,yW
// width - \
GraphAxis.prototype.drawHorizontal=function(x0,y0,width){
  context.beginPath();
  context.moveTo(x0,y0);
  context.lineTo(x0+width,y0);
  var ty=y0+1,metrix;
  for(var i=0;i<this.scaleLabel.length;i++){
    var x=this.fromScaleToView(this.scaleMin+this.scale*i);
    context.moveTo(x,y0);
    context.lineTo(x,y0-SCALE_SIZE);
    metrix=context.measureText(this.scaleLabel[i]);
    context.fillText(this.scaleLabel[i],parseInt(x-metrix.width/2),ty);
  }
  context.closePath();
  context.stroke();
  metrix=context.measureText(this.text);
  context.fillText(this.text,parseInt(x0+(width-metrix.width)/2),
      	      	   ty+FONT_SIZE);
};

// `悷
// x0,y0 - x,yW
// height - \
GraphAxis.prototype.drawVertical=function(x0,y0,height){
  context.beginPath();
  context.moveTo(x0,y0);
  context.lineTo(x0,y0+height);
  var dy=parseInt(FONT_SIZE/2)+2,metrix;
  for(var i=0;i<this.scaleLabel.length;i++){
    var y=this.fromScaleToView(this.scaleMin+this.scale*i);
    context.moveTo(x0,y);
    context.lineTo(x0+SCALE_SIZE,y);
    metrix=context.measureText(this.scaleLabel[i]);
    context.fillText(this.scaleLabel[i],x0-metrix.width-2,y-dy);
  }
  context.closePath();
  context.stroke();
  metrix=context.measureText(this.text);
  context.fillText(this.text,parseInt(x0-metrix.width/2),
      	      	   y0-FONT_SIZE-dy);
};

// ڐ̐l𕶎ɕϊ
// s - ڐ̐l
GraphAxis.prototype.toLabel=function(s){
  return String(s);
};

// ڐ̐l`ʒuɕϊ
// s - ڐ̐l
GraphAxis.prototype.fromScaleToView=function(s){
  return this.toView(s);
};

//--------------------------------------------------------------------//
// WJ[o[i`΁`ԁj̐FԂ
// z - f[^i0`1j
function colorBar(z){
  var r=0,g=0,b=0;
  z=Math.min(4*z,4);
  if(z<=0){
    b=255;
  }
  else if(z<1){
    g=parseInt(255*z);
    b=255;
  }
  else if(z<2){
    g=225+parseInt(30*(2-z));
    b=parseInt(255*(2-z));
  }
  else if(z<3){
    r=parseInt(255*(z-2));
    g=225+parseInt(30*(z-2));
  }
  else{
    r=255;
    g=parseInt(255*(4-z));
  }
  return 'rgb('+r+','+g+','+b+')';
}
